interface Collection<T> {
    add(t: T): void;
    remove(t: T): void;
    asArray(): T[];
}

interface List<T> extends Collection<T>{
    getElementAt(index: number): T;
}

class ArrayList<T> implements List<T> {
    private data: T[] = [];

    add(t: T): void {
        this.data.push(t);
    }

    remove(t: T): void {
        let index = this.data.indexOf(t);
        if (index > -1) {
            this.data.splice(index, 1);
        }
    }

    asArray(): T[] {
        return this.data;
    }

    getElementAt(index: number): T {
        return this.data[index];
    }
}


let numbers: List<Number> = new ArrayList();
numbers.add(11);
numbers.add(13);
let numArray = numbers.asArray();
console.log(numArray);
let secondElement = numbers.getElementAt(1);
console.log(secondElement);