interface Collection<T> {
    add(t: T): void;
    remove(t: T): void;
    asArray(): T[];
}

class List<T> implements Collection<T> {
    private data: T[] = [];

    add(t: T): void {
        this.data.push(t);
    }

    remove(t: T): void {
        let index = this.data.indexOf(t);
        if (index > -1) {
            this.data.splice(index, 1);
        }
    }

    asArray(): T[] {
        return this.data;
    }
}

class BoolList extends List<boolean>{}

let numbers: Collection<number> = new List();
numbers.add(11);
numbers.add(12);
numbers.add(13);
numbers.remove(12);
let numArray = numbers.asArray();
console.log(numArray);

let boolList: BoolList = new BoolList();
boolList.add(true);
boolList.add(false);
console.log(boolList.asArray());